import React from 'react';

import containerAPI from '../../common/ContainerAPI';

class CntrAPIComponent extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      logInfo: '',
      geoInfo: ''
    };
  }

  setLog() {
    containerAPI.sendLog({
      event: 'click_demo_log',
      label: JSON.stringify({ source: 'rexxar' })
    }).then(() => {
      this.setState({
        logInfo: 'success'
      });
    }).catch(() => {
      this.setState({
        logInfo: 'failure'
      });
    });
  }

  getGeo() {
    containerAPI.getGeo().then((data) => {
      this.setState({
        geoInfo: JSON.stringify(data)
      });
    }).catch((error) => {
      this.setState({
        geoInfo: JSON.stringify(error.message)
      });
    });
  }

  render() {
    return (
      <section>
        <h1>Container Api</h1>
        <section>
          <div>{`event:'click_demo_log',label:{source:'rexxar'} ${this.state.logInfo}`}</div>
          <input type='button' onClick={this.setLog.bind(this)} value='Send Log' />
        </section>
        <section>
          <div>经纬度：{this.state.geoInfo}</div>
          <input type='button' onClick={this.getGeo.bind(this)} value='Get GEO info' />
        </section>
      </section>
    )
  }
}

export default CntrAPIComponent;
